package com.hfkj.service;

import com.hfkj.entity.BsStore;
import com.hfkj.model.MerBasisModel;
import com.hfkj.model.OpenStoreModel;
import com.hfkj.model.StoreModel;
import com.hfkj.sysenum.StoreCreateTypeEnum;

import java.util.List;
import java.util.Map;

/**
 * 门店
 * @author hurui
 */
public interface BsStoreService {

    /**
     * 配置门店
     * @param store 门店信息
     */
    void configStore(StoreModel store) throws Exception;

    /**
     * 编辑门店
     * @param store
     */
    void editStore(BsStore store);

    /**
     * 根据id 查询门店信息
     * @param storeId 门店id
     * @return
     */
    BsStore getStoreById(Long storeId);

    /**
     * 根据门店号查询门店信息
     * @param storeNo
     * @return
     */
    BsStore getStoreByStoreNo(Long storeNo);

    /**
     * 根据id 查询门店详情
     * @param storeId
     * @return
     */
    StoreModel getStoreDetail(Long storeId);

    /**
     * 根据商户查询
     * @param merId
     * @param typeEnum
     * @return
     */
    List<BsStore> getStoreByMerId(Long merId, StoreCreateTypeEnum typeEnum);

    /**
     * 查询门店列表
     * @param param
     * @return
     */
    List<StoreModel> getStoreList(Map<String, Object> param);

    /**
     * @Author Sum1Dream
     * @Name getStoreList
     * @Description // 根据名称查询对外门店列表
     * @Date 17:21 2023/4/23
     * @Param [name]
     * @Return java.util.List<com.hfkj.entity.BsStore>
     */
    List<OpenStoreModel> getStoreList(String name , Long childId);

    /**
     * 统计门店交易
     * @param param
     * @return
     */
    Map<String, Object> countStoreTrade(Map<String, Object> param);
}
